//	    ------------------------------------
//	       FLIB v1.7  par Franois LEIBER
//	       Francois.leiber@libertysurf.fr
//	            Compil avec Ti-gcc
//	  Librairies documentes par Zeljko Juric
//		        30/05/2000
//	    ------------------------------------


// Je pense que toutes les fonctions crites ici sont  peu prs transparentes, si vous ne comprenez pas quelque chose qui vous
// semble important, vous pouvez toujours m'crire, j'essaie de rpondre  tout le monde :)

// I think all the functions written here are quite transparent, so if ever you don't understand something that seems important
// to you, you can write to me, I do my best to answer to everybody :)

#include <nostub.h>
#include <all.h>

#define _92		//remplacer par _92 pour avoir une version 92+

#ifdef _89
int _ti89;
#define _89_92(x, y) (x)
#else
int _ti92plus;
#define _89_92(x, y) (y)
#endif

int num = 0;

/////////////////////////////////////////////////////////////////////////////////////////
//	Place dans 'tableau' un maximum de 'max_arg' arguments numriques contenus dans 'str'
//	 partir du caractre 'debut'.
//
//	Places in 'tableau' a maximum of 'max_arg' numerical arguments stocked in 'str', and
//	beginning at character 'debut'.
/////////////////////////////////////////////////////////////////////////////////////////

int arguments(char *str, int debut, int *tableau, int max_arg)
{
	int rang = debut, numero = 0;
	while (((str[rang] == ',')||(str[rang] == '.')||(str[rang] >= '0')&&(str[rang] <= '9'))&&(numero < max_arg))
	{
		if ((str[rang] == ',')||(str[rang] == '.'))
		{
			for (tableau[numero]=0; debut<rang; debut++) tableau[numero] += (str[debut]-'0')*((debut == rang-1)?(1):((debut == rang-2)?(10):((debut == rang-3)?(100):((debut == rang-4)?(1000):(10000)))));
			numero++; debut++;
		}
		if (str[rang++] == '.')	{ while ((str[rang] >= '0')&&(str[rang] <= '9')) rang++; rang++; debut = rang; }
	}
	if ((str[debut] >= '0')&&(str[debut] <= '9'))
		for (tableau[numero]=0; debut<rang; debut++) tableau[numero] += (str[debut]-'0')*((debut == rang-1)?(1):((debut == rang-2)?(10):((debut == rang-3)?(100):((debut == rang-4)?(1000):(10000)))));
	return rang;
}

/////////////////////////////////////////////////////////////////////////////////////////
//	Ajoute  'retour' la chane pointe par 'str' en respectant les conventions du TIOS,
//	'retour' sera ensuite stocke dans 'fl'.
//
//	Adds to 'retour' the string pointed by 'str', respecting the TIOS conventions, 
//	'retour' will be copied in 'fl' at the end.
/////////////////////////////////////////////////////////////////////////////////////////

void str_add(char *str, char *retour)
{
	retour[num] = 0x2D;
	retour[num-1] = 0;
	num -= strlen(str)+3;
	memcpy((retour+num+2), str, strlen(str));
	retour[num+1] = 0;
}

/////////////////////////////////////////////////////////////////////////////////////////
//	Ajoute  'retour' l'entier n, retour sera ensuite stocke dans 'fl'.
//
//	Adds to 'retour' the integer n, 'retour' will be copied in 'fl' at the end.
/////////////////////////////////////////////////////////////////////////////////////////

void int_add(unsigned int n, char *retour)
{
	if (n >= 256)
	{
		num -= 4;
		retour[num+1] = n%256;
		retour[num+2] = n/256;
		retour[num+3] = 2;
		retour[num+4] = 0x1F;
	}
	else
	{
		num -= 3;
		retour[num+1] = n;
		retour[num+2] = 1;
		retour[num+3] = 0x1F;
	}
}

/////////////////////////////////////////////////////////////////////////////////////////
//	Renvoie un pointeur vers la variable dont le nom est stock  partir du i-ime
//	caractre de 'str'.
//
//	Returns a structure pointing to the symbol whose name is stocked in 'str', beginning
//	at the character 'i'.
/////////////////////////////////////////////////////////////////////////////////////////

SYM_ENTRY *get_ptr(char *str, int i)
{
	char name[18];
	name[0] = 0;
	return SymFindPtr(strcpy(name+1, str+i)+strlen(str+i), 0);
}

/////////////////////////////////////////////////////////////////////////////////////////
//	Cre un pointeur vers un variable dont le nom est pris  partir du i-ime 
//	caractre de 'str', et alloue  la variable une place en mmoire 'taille'.
//
//	Creates a pointer to a variable whose name is stocked in 'str' beginning at the 
//	caracter 'i', and allocates the variable a place 'taille' bytes long in memory.
/////////////////////////////////////////////////////////////////////////////////////////

unsigned char *mk_ptr(char *str, int i, unsigned int taille)
{
	unsigned char name[18], *nam;
	SYM_ENTRY *entry;

	name[0] = 0;
	entry = DerefSym(SymAdd(strcpy(name+1, str+i)+strlen(str+i)));
	entry->flags.bits.archived = 0;
	nam = (unsigned char*)HeapDeref(entry->handle = HeapAlloc(taille));
	nam[0] = (taille-2)/256;
	nam[1] = (taille-2)%256;
	return nam;
}

/////////////////////////////////////////////////////////////////////////////////////////
//	Renvoie la taille de la variable pointe par 'var'.
//
//	Returns the size of the variable pointed by 'var'.
/////////////////////////////////////////////////////////////////////////////////////////

unsigned int var_len(unsigned char *var)
{
	return (unsigned int)(256*(*var)+*(var+1)+2);
}

/////////////////////////////////////////////////////////////////////////////////////////
//	Procdure de dpart.
//
//	Main entry point.
/////////////////////////////////////////////////////////////////////////////////////////

void _main()
{
	int handlenum;
	unsigned int i, j, rang, numero;
	unsigned int tableau[9];
	SCR_RECT rect, ECRAN = {0, 0, _89_92(159, 239), _89_92(99, 127)};
	WIN_RECT wrect;
	unsigned char *nam, *hsmsg = "highscores by flib";
	unsigned char str[999], name[18], name2[10], retour[999];
	SYM_ENTRY *entry;
	HSym hsym;
	ESI arg;
	HANDLE handle;
	LCD_BUFFER lcd;

	num = 999;

	InitArgPtr(arg);
	while((GetArgType(arg) != END_TAG)&&(GetArgType(arg) == STR_TAG))
	{
		strncpy(str, GetStrnArg(arg), 999);

/*------------------------------		D  un bug de l'optimisation de ti-gcc (je pense), je dois
    FONCTIONS SANS ARGUMENTS			rassembler les fonctions sans arguments au dbut...
--------------------------------*/

		if (!strcmp(str, "version")) str_add("Flib v1.7 by Francois Leiber", retour);

		else if (!strcmp(str, "off")) off();

		else if (!strcmp(str, "clrscr")) ClrScr();

		else if (!strcmp(str, "+")) OSContrastUp();

		else if (!strcmp(str, "-")) OSContrastDn();

		else if (!strcmp(str, "reset")) OSReset();

		else if (!strcmp(str, "breakoff")) { OSClearBreak(); OSDisableBreak(); OSSetSR(0x0700); }
		
		else if (!strcmp(str, "slclr")) for (i=_89_92(94, 122); i<=_89_92(99, 127); i++) DrawLine(0, i, _89_92(159, 239), i, 0);

		else if (!strcmp(str, "slrcl")) DrawLine(0, _89_92(93, 121), _89_92(159, 239), _89_92(93, 121), 1);

		else if (!strcmp(str, "keywait")) int_add(ngetchx(), retour);

		else if (!strcmp(str, "keylow"))
		{
			i = _rowread(0xfffe);
			#ifdef _89
				name[0] = (16&i)?('1'):('0');
				name[1] = (32&i)?('1'):('0');
				name[2] = (64&i)?('1'):('0');
				name[3] = (128&i)?('1'):('0');
				name[4] = (2&i)?('1'):('0');
				name[5] = (8&i)?('1'):('0');
				name[6] = (1&i)?('1'):('0');
				name[7] = (4&i)?('1'):('0');
			#else
				name[0] = (1&i)?('1'):('0');
				name[1] = (4&i)?('1'):('0');
				name[2] = (2&i)?('1'):('0');
				name[3] = (8&i)?('1'):('0');
				name[4] = (16&i)?('1'):('0');
				name[5] = (64&i)?('1'):('0');
				name[6] = (32&i)?('1'):('0');
				name[7] = (128&i)?('1'):('0');
			#endif
			name[8] = 0;
			str_add(name, retour);
		}

		else if (!strcmp(str, "getfolder")) 
		{
			entry = SymFindFirst(NULL, 4);
			while(entry)
			{
				str_add(entry->name, retour);
				entry = SymFindNext();
			}
		}

/*-------------------------
    FONCTIONS GENERALES
---------------------------*/

		else if (!strncmp(str, "wait:", 5))
		{
			arguments(str, 5, tableau, 1);
			for (j=0; j<tableau[0]; j++)
				for (i=0; i<41500; i++);
		}

		else if (!strncmp(str, "apd:", 4))
		{
			int_add((int)OSTimerCurVal(2)/20+1, retour);
			arguments(str, 4, tableau, 1);
			OSFreeTimer(2);
			OSRegisterTimer(2, 20*tableau[0]);
		}

		else if (!strncmp(str, "blink:", 6))
		{
			arguments(str, 6, tableau, 1);
			OSFreeTimer(4);
			OSRegisterTimer(4, 2*tableau[0]);
		}

		else if (!strncmp(str, "error:", 6))
		{
			arguments(str, 6, tableau, 1);
			ERD_dialog(tableau[0], FALSE);
		}

/*--------------------------
    FONCTIONS GRAPHIQUES
----------------------------*/

		else if (!strncmp(str, "sprite:", 7))
		{
			tableau[0] = 0;
			tableau[1] = 0;
			tableau[2] = 1;
			nam = (unsigned char*)HeapDeref(get_ptr(str, arguments(str, 7, tableau, 3))->handle);
			if (*(nam+var_len(nam)-1) == 223) 
				BitmapPut(tableau[0], tableau[1], nam+2, &ECRAN, tableau[2]);
		}

		else if (!strncmp(str, "savpic:", 7))
		{
			i = arguments(str, 7, tableau, 4);
			j = (tableau[2]-tableau[0]+8)/8*(tableau[3]-tableau[1]+1)+5;
			nam = mk_ptr(str, i, j+2);
			rect = (SCR_RECT){tableau[0], tableau[1], tableau[2], tableau[3]};
			BitmapGet(&rect, nam+2);
			nam[j+1] = 0xDF;
		}

		else if (!strncmp(str, "mkpic:", 6))
		{
			rang = arguments(str, 6, tableau, 2);
			i = rang+1;
			while (str[i++] != ',') {}
			str[i-1] = 0;
			j = (tableau[0]+7)/8*tableau[1];
			nam = mk_ptr(str, rang, j+7);
			nam[2] = 0;
			nam[3] = tableau[1];
			nam[4] = 0;
			nam[5] = tableau[0];
			memcpy(nam+6, str+i, j);
			nam[j+6] = 0xDF;
		}

		else if (!strncmp(str, "savscr:", 7))
		{
			nam = mk_ptr(str, 7, _89_92(2007, 3847));
			BitmapGet(&ECRAN, nam+2);
			nam[_89_92(2006, 3846)] = 0xDF;
		}

		else if (!strncmp(str, "rclscr:", 7))
		{
			nam = (unsigned char*)HeapDeref(get_ptr(str, 7)->handle);
			if (*(nam+var_len(nam)-1) == 223) 
			BitmapPut(0, 0, nam+2, &ECRAN, 4);
		}

		else if (!strncmp(str, "picsize:", 8))
		{
			entry = get_ptr(str, 8);
			nam = (unsigned char*)HeapDeref(entry->handle);
			int_add((entry)?(var_len(nam+4)-2):(0), retour);
			int_add((entry)?(var_len(nam+2)-2):(0), retour);
		}

		else if (!strncmp(str, "rect:", 5))
		{
			tableau[4] = 1;
			arguments(str, 5, tableau, 5);
			DrawClipRect(MakeWinRect(tableau[0], tableau[1], tableau[2], tableau[3]) , &ECRAN, tableau[4]);
		}

		else if (!strncmp(str, "fillrect:", 9))
		{
			tableau[3] = 1;
			arguments(str, 9, tableau, 5);
			rect = (SCR_RECT){tableau[0], tableau[1], tableau[2], tableau[3]};
			ScrRectFill(&rect, &ECRAN, tableau[4]);
		}

		else if (!strncmp(str, "filltri:", 8))
		{
			tableau[6] = 1;
			arguments(str, 8, tableau, 7);
			FillTriangle(tableau[0], tableau[1], tableau[2], tableau[3], tableau[4], tableau[5], &ECRAN, tableau[6]); 
		}

		else if (!strncmp(str, "fillpoly:", 9))
		{
			tableau[8] = 1;
			arguments(str, 9, tableau, 9);
			wrect = (WIN_RECT){tableau[0], tableau[1], tableau[2], tableau[3]};
			FillLines2(&wrect, MakeWinRect(tableau[4], tableau[5], tableau[6], tableau[7]), &ECRAN, tableau[8]); 
		}

		else if (!strncmp(str, "ellipse:", 8))
		{
			tableau[4] = 1;
			arguments(str, 8, tableau, 5);
			DrawClipEllipse(tableau[0], tableau[1], tableau[2], tableau[3] , &ECRAN, tableau[4]);
		}

		else if (!strncmp(str, "line:", 5))
		{
			tableau[4] = 1;
			arguments(str, 5, tableau, 5);
			DrawClipLine(MakeWinRect(tableau[0], tableau[1], tableau[2], tableau[3]), &ECRAN, tableau[4]);
		}

		else if (!strncmp(str, "pix:", 4))
		{
			tableau[2] = 1;
			arguments(str, 4, tableau, 3);
			DrawPix(tableau[0], tableau[1], tableau[2]);
		}

/*---------------------
    FONCTIONS TEXTE
-----------------------*/

		else if (!strncmp(str, "font:", 5)) FontSetSys(str[5] - '0');

		else if (!strncmp(str, "drawstr:", 8))
		{
			tableau[2] = 1;
			i = arguments(str, 8, tableau, 3);
			DrawStr(tableau[0], tableau[1], str+i, tableau[2]);
		}

		else if (!strncmp(str, "width:", 6))
		{
			i = arguments(str, 6, tableau, 1);
			int_add(DrawStrWidth(str+i, tableau[0]), retour);
		}
		
		else if (!strncmp(str, "msg:", 4))
		{
			LCD_save(lcd);
			str[_89_92(29, 42)] = 0;
			j = FontSetSys(1);
			i = (_89_92(160, 240)-DrawStrWidth((str+4), 1))/2;
			rect = (SCR_RECT){i-5, _89_92(39, 53), _89_92(165, 245)-i, _89_92(59, 73)};
			ScrRectFill(&rect, &ECRAN, 0);
			rect = (SCR_RECT){i-4, _89_92(41, 55), _89_92(164, 244)-i, _89_92(57, 71)};
			ScrRectFill(&rect, &ECRAN, 1);
			DrawClipRect(MakeWinRect(i-3, _89_92(40, 54), _89_92(163, 243)-i, _89_92(58, 72)) , &ECRAN, 1);
			DrawClipRect(MakeWinRect(i-2, _89_92(42, 56), _89_92(162, 242)-i, _89_92(56, 70)) , &ECRAN, 0);
			DrawStr(i, _89_92(46, 60), str+4, 2);
			FontSetSys(j);
			int_add(ngetchx(), retour);
			LCD_restore(lcd);
		}

		else if (!strncmp(str, "menu:", 5))
		{
			for (i=0; i<=2; i++) tableau[i] = CENTER;
			j = i = arguments(str, 5, tableau, 3);
			while (str[j++] != ',') {}
			str[j-1] = 0;
			handle = PopupNew(str+i, tableau[0]);
			rang = j; handlenum = -1; numero = 0;
			while (str[rang])
			{
				if ((str[rang] == ',')||(str[rang] == '|'))
				{
					i = str[rang];
					str[rang] = 0;
					if ((i == '|')&&(handlenum == -1)) handlenum = 0;
					PopupAddText(handle, handlenum, str+j, ++numero);
					j = rang+1;
					if (i == ',') handlenum = -1;
					else if (!handlenum) handlenum = numero;
				}
				rang++;
			}
			PopupAddText(handle, handlenum, str+j, numero+1);
			int_add(PopupDo(handle, tableau[1], tableau[2], 0), retour);
			HeapFree(handle);
		}

/*--------------------------------
    FONCTIONS DE LA STATUS LINE
----------------------------------*/

		else if (!strncmp(str, "slmsg:", 6)) ST_helpMsg(str+6);

		else if (!strncmp(str, "busy:", 5)) ST_busy(str[5]-'0');

/*-----------------------
    FONCTIONS TOUCHES
-------------------------*/

		else if (!strncmp(str, "initdelay:", 10))
		{
			arguments(str, 10, tableau, 1);
			int_add(OSInitKeyInitDelay(tableau[0]), retour);
		}

		else if (!strncmp(str, "delay:", 6))
		{
			arguments(str, 6, tableau, 1);
			int_add(OSInitBetweenKeyDelay(tableau[0]), retour);
		}

/*---------------------------
    FONCTIONS HIGH-SCORES
-----------------------------*/

		else if (!strncmp(str, "mkhs:", 5))
		{
			tableau[0] = 0;
			j = i = arguments(str, 5, tableau, 2);
			while (str[j++] != ',') {}
			str[(j-i <= 11)?(j-1):(i+10)] = 0;
			nam = mk_ptr(str, j, 13*tableau[0]+24);
			for (rang=0; rang<tableau[0]; rang++)
			{
				strcpy(nam+13*rang+2, str+i);
				nam[13*rang+13] = tableau[1]/256;
				nam[13*rang+14] = tableau[1]%256;
			}
			nam[13*tableau[0]+3] = 0;
			strcpy(nam+13*tableau[0]+4, hsmsg);
			nam[13*tableau[0]+23] = 0x2D;
		}

		else if (!strncmp(str, "puths:", 6))
		{
			j = rang = arguments(str, 6, tableau, 1);
			while (str[j++] != ',') {}
			str[(j-rang <= 11)?(j-1):(rang+10)] = 0;
			entry = get_ptr(str, j);
			if (entry)
			{
				entry->flags.bits.archived = 0;
				nam = (unsigned char*)HeapDeref(entry->handle);
				for (i=0; i<=var_len(nam)-30; i+=13)
				{
					if (tableau[0] > 256**(nam+i+13)+*(nam+i+14))
					{
						for (j=var_len(nam)-50; j>=i; j-=13)
						{
							strcpy(nam+j+15, nam+j+2);
							nam[j+26] = nam[j+13];
							nam[j+27] = nam[j+14];
							if (!j) break;
						}
						strcpy(nam+i+2, str+rang);
						nam[i+13] = tableau[0]/256;
						nam[i+14] = tableau[0]%256;
						break;
					}
				}
				int_add((i > var_len(nam)-30)?(0):(i/13+1), retour);
			}
		}

		else if (!strncmp(str, "geths:", 6)) 
		{
			i = arguments(str, 6, tableau, 1);
			name[0] = 0;
			entry = get_ptr(str, i);
			nam = (unsigned char*)HeapDeref(entry->handle);
			if ((!strcmp(nam+var_len(nam)-20, hsmsg))&&(tableau[0] > 0)&&(13*tableau[0]+12 < 256**nam+*(nam+1)))
			{
				str_add(nam+13*tableau[0]-11, retour);
				int_add(256**(nam+13*tableau[0])+*(nam+13*tableau[0]+1), retour);
			}			
		}

/*-------------------------
    FONCTIONS VARIABLES
---------------------------*/

		else if (!strncmp(str, "hide:", 5)) 
		{
			entry = get_ptr(str, 5);
			if (entry) entry->flags.bits.hidden = 1;
		}

		else if (!strncmp(str, "unhide:", 7)) 
		{
			entry = get_ptr(str, 7);
			if (entry) entry->flags.bits.hidden = 0; 
		}

		else if (!strncmp(str, "size:", 5))
		{
			entry = get_ptr(str, 5);
			int_add((entry)?(var_len((unsigned char*)HeapDeref(entry->handle))):(0), retour);
		}

		else if (!strncmp(str, "state:", 6)) 
		{
			entry = get_ptr(str, 6);
			if (entry) int_add(4*(entry->flags.bits.hidden)+2*(entry->flags.bits.locked)+(entry->flags.bits.archived), retour);
		}

		else if (!strncmp(str, "folder:", 7))
		{
			entry = SymFindFirst(NULL, 4);
			name[0] = 0;
			name2[0] = 0;
			while(entry)
			{
				hsym = FindSymInFolder(strcpy(name+1, str+7)+strlen(str+7), strcpy(name2+1, entry->name)+strlen(entry->name));
				if (DerefSym(hsym)) str_add(entry->name, retour);
				entry = SymFindNext();
			}
		}

		else if (!strncmp(str, "getfile:", 8)) 
		{
			i = arguments(str, 8, tableau, 1);
			name[0] = 0;
			entry = SymFindFirst(strcpy(name+1, str+i)+strlen(str+i), 1);
			while (entry)
			{
				nam = (unsigned char*)HeapDeref(entry->handle);
				if ((*(nam+var_len(nam)-1) == tableau[0])||(i == 8)) str_add(entry->name, retour);
				entry = SymFindNext();
			}
		}

		else if (!strncmp(str, "getbyte:", 8))
		{
			tableau[1] = 0;
			i = arguments(str, 8, tableau, 2);
			entry = get_ptr(str, i);
			nam = (unsigned char*)HeapDeref(entry->handle);
			if (tableau[1])
			{
				retour[num] = 0x2D;
				retour[num-1] = 0;
				num -= tableau[1]+3;
				memcpy((retour+num+2), nam+tableau[0]+2, tableau[1]);
				retour[num+1] = 0;
			}
			else
				int_add((unsigned char)*(nam+tableau[0]+2), retour);
		}

		else if (!strncmp(str, "setbyte:", 8))
		{
			entry = get_ptr(str, arguments(str, 8, tableau, 2));
			nam = (unsigned char*)HeapDeref(entry->handle);
			*(nam+tableau[0]+2) = tableau[1];
		}

		else if (!strncmp(str, "crypt:", 6))
		{
			nam = (unsigned char*)HeapDeref(get_ptr(str, arguments(str, 6, tableau, 1))->handle);
			srand(tableau[0]);
			for (i=6; i<=var_len(nam)-2; i++) *(nam+i) = (*(nam+i))^(BYTE)random(256);
		}

}

	nam = (char*)HeapDeref(DerefSym(SymAdd($(fl)))->handle = HeapAlloc(1003-num)); 
	nam[0] = (1001-num)/256;
	nam[1] = (1001-num)%256; 
	nam[2] = 0xE5;
	memcpy(nam+3, retour+num+1, 999-num);
	nam[1002-num] = 0xD9;

}
